#!/usr/bin/perl

##################################################################
#IP-Generator by bighawk                                         #
#                        sep 2000                                #
#                                                                #
#PRIVATE-DO NOT DISTRIBUTE-PRIVATE (not anymore, heh)            #
#                                                                #
#Try --help for possible options                                 #
#                                                                #
#questions or comments? mail bighawk@warfare.com                 #
#for all those annoying programs requesting an ip-list as input..#
#                                                                #
#ugly code, i'm not gonna fix it because it works..              #
#Thanks fut0n for testing and giving me some ideas.              #
##################################################################

if ($ARGV[0] eq "--help") {
   print "\tIP-generator by bighawk\n";
   print "Syntax: $0 <ip-pattern> <outfile> [option] [--bypass-sanchk]\n";
   print "IP-generator has a powerfull range specification syntax.\n";
   print "Supported are:\n";
   print "  * :For all 256 possibilities.\n";
   print "  , :To seperate single numbers.\n";
   print "  - :To specify number-ranges.\n";
   print "Example: 112.*.1-10,15,20-40.0,255\n";
   print "Print output to specified outfile. Try STDOUT.\n";
   print "Supported options are:\n";
   print " --resolve :Try to resolve generated ips.\n";
   print " --resolved-only :Only print resolved ips to outfile\n";
   print "Warning: Both resolving options slow down the program significantly..\n";
   print " --bypass-sanchk :To bypass the built-in ip-part sanity check.\n";
   print "Tip: You can use it as a \"ip-resolve-script\".\n";
   exit;
}
if ($ARGV[1] eq "STDOUT") {                           # Check if outfile = STDOUT if so linking LOG to STDOUT
   $outfile = "&STDOUT";                               
} else {
   $outfile = $ARGV[1];                               
}
if ($ARGV[2]) {
      $opt = 1 if ($ARGV[2] eq "--resolve");
      $opt = 2 if ($ARGV[2] eq "--resolved-only");                                  # Checking for various options
      $san = 1 if ($ARGV[2] eq "--bypass-sanchk" || $ARGV[3] eq "--bypass-sanchk"); #
      die "Error: unknown option $ARGV[2]. Try --help\n" unless ($opt || $san);     # and die if non-valid.
}
die "Error: not enough parameters. Try --help\n" unless ($ARGV[0]);
$ip_pattern = $ARGV[0];
die "Error: unsupported pattern. Try --help.\n" unless ($ip_pattern =~ /[0-9\-,*]+\.[0-9\-,*]+\.[0-9\-,*]+\.[0-9\-,*]+/);
($ip_part1, $ip_part2, $ip_part3, $ip_part4) = split(/\./, $ip_pattern);

@part1 = &checkpart("$ip_part1");    #
@part2 = &checkpart("$ip_part2");    # send each part of the ip-pattern to subroutine checkpart()
@part3 = &checkpart("$ip_part3");    # which returns the list of matched numbers.
@part4 = &checkpart("$ip_part4");    #

die "Error: Couldn't open outfile.\n" unless (open(LOG, ">$outfile"));

for ($a = 0; $a < @part1; $a++) {                                       #
   for ($b = 0; $b < @part2; $b++) {                                    #
      for ($c = 0; $c < @part3; $c++) {                                 # nested loop generating the ips
         for ($d = 0; $d < @part4; $d++) {                              # 
            $b_ip = "$part1[$a].$part2[$b].$part3[$c].$part4[$d]";
            if ($opt) {                                                 # check if ip needs to be resolved
               @host = "";                                              
               @addrbytes = ($part1[$a], $part2[$b], $part3[$c], $part4[$d]);
               $paddr = pack ("C4", @addrbytes);                        # packing ip to 4 bytes integer
               @host = gethostbyaddr($paddr, 2);                        # and resolve
               next if ($host[0] eq "" && $opt == 2);                   # next if unresolveble and --resolved-only is set
               $host[0] ? print LOG "$host[0]\n" : print LOG "$b_ip\n"; # if ip resolved print $host, otherwise print $b_ip
            } else {
               print LOG "$b_ip\n";                                     # print $b_ip if no resolving options are specified
            }
         }
      }
   }
}

close(LOG);
print "Done\n";

sub checkpart {
   my ($part) = @_;
   my (@returnlist);
   my (@tmp);
   if ($part =~ /^\d+$/) {                       # check if $part is a normal digit
      &sanchk($part);                            # first call to subroutine sanchk().
      $returnlist[0] = $part;                    
   } elsif  ($part =~ /\*/) {                    # check if $part is an asterisk
      for ($a = 0; $a <= 255; $a++) {            # generating the 256 possibilities
         $returnlist[$a] = $a;
      }
   } elsif ($part =~ /\d+,\d+/) {                # check if $part matches the seperator ","
      @tmp = split(/\,/, $part);                 # split $part and assign to a temporary array
      my ($num);     
      for ($cnt = 0; $cnt < @tmp; $cnt++) {      # looping trough @tmp to see if it contains ranges (-)
         if ($tmp[$cnt] =~ /(\d+)-(\d+)/) {      # if it does contain a range, generating all possibilities
            &sanchk($1);
            &sanchk($2);
            for ($a = $1; $a <= $2; $a++) {
               $returnlist[$num] = $a;           # and assigning them to @returnlist
               $num++;
            }
         } else {                                # if not, assign each number to @returnlist
            &sanchk($tmp[$cnt]);
            $returnlist[$num] = $tmp[$cnt];
            $num++;
         }
      }

   } elsif ($part =~ /^(\d+)-(\d+)$/) {          # check if $part contains only a range
      my $b = 0;
      for ($a = $1; $a <= $2; $a++) {            # looping trough the range and generating all possibilities 
         &sanchk($a);
         $returnlist[$b] = $a;                   # and assign them to @returnlist
         $b++;
      }
   } else {                                      # if none matched, "pattern" can't be handled
      die "Error: Can not handle $part.\n";
   }
   @returnlist;                                  # return @returnlist
}

sub sanchk {                                              # Subroutine sanchk() checks if ip_parts are valid ip_parts.
   return if ($san == 1);                                 # return if --bypass-sanchk is specified.
   my ($part) =  @_;
   if ($part < 0 || $part > 255) {
      die "Error: ip-parts must be between 0 and 255\n";
   }
}
